<?php

class cg_pages_core {
	
	var $version="2011.08.10"; 	
	var $alt=false;
	var $exes=array();
	var $google_blocked=array();	
	var $site = "";
	var $context = "";	
	
	function __construct(){
		
		$this->site = get_bloginfo("wpurl");
		
		add_action("wp_print_scripts", array(&$this,"cssAndScripts"));
		
		// ajax responses		
			
		add_action('wp_ajax_enCO', array(&$this,"ajax_enCO"));
		add_action('wp_ajax_googleBlock', array(&$this,"ajax_googleBlock"));
		add_action('wp_ajax_include', array(&$this,"ajax_include"));
		add_action('wp_ajax_exclude', array(&$this,"ajax_exclude"));		
		add_action('wp_ajax_delPost', array(&$this,"ajax_delPost"));			
	} //func
			

	function processMassActions(){	
	global $wpdb;	
		extract($_POST);
		if($submit=="Apply" && $mass_ids!=""){			
			$ids = explode(",",$mass_ids);	
			foreach($ids as $id){
				switch($mass_action){					
					case "google-search-in": $this->ajax_googleBlock($id,"-"); break;
					case "google-search-ex": $this->ajax_googleBlock($id,"allowed"); break;					
					case "comment-close": $this->ajax_enCOMass($id,"closed"); break;
					case "comment-open": $this->ajax_enCOMass($id,"open"); break;
					case "batch-delete": wp_delete_post($id); break;
					case "draft":  
					case "publish": 
					case "private":  $this->setStatus($mass_action, $id); break;  																							
				}
			}
		}
	} //func		
	
	function setStatus($stat,$id){
		global $wpdb;
		$wpdb->query("UPDATE $wpdb->posts SET post_status='$stat' WHERE ID='$id'");		
	}
	

	function isPost(){
		return isset($_POST["post_type"]) && $_POST["post_type"]=="post";
	}//func	
	

	function getPageSettings(){
		global $wpdb;
		
		// get excludes;
		
		$ex = $wpdb->get_results("SELECT 
									  $wpdb->postmeta.post_id,
									  $wpdb->postmeta.meta_value
									FROM
									  $wpdb->postmeta 
									WHERE meta_key='_widgets_exclude'");	
		foreach($ex as $x){
			$this->exes[$x->post_id]=$x->meta_value?"excluded":"-";
		}			
		
		// get google blocked;
		
		$goog_block_string = "_cg_google_blocked";
		
		$ex = $wpdb->get_results("SELECT 
									  $wpdb->postmeta.post_id,
									  $wpdb->postmeta.meta_value
									FROM
									  $wpdb->postmeta 
									WHERE meta_key='$goog_block_string'");	
									
		foreach($ex as $x){
			$this->google_blocked[$x->post_id]=$x->meta_value?"blocked":"allowed";
		}			
	}//func	
	
	function listPages($type, $isParent, $parent=0, $level, $category=0){	
		global $wpdb;
				
		$status = isset($_POST["post_status"])?$_POST["post_status"]:"publish";
		
		if($type=="page"){
			if($isParent){
				$xpages = $this->getAllPages("page",$status,$parent,true,0);
			} else {
				$xpages = $this->getAllPages("page",$status,$parent,false,$category);
			}
		} else {
			$xpages = $this->getAllPages("post",$status,$parent,false,$category);
		}																
		
		$xsiteurl = get_bloginfo("siteurl");
		
		if(count($xpages)){				  			  
			
			foreach($xpages as $p){								
				$ID=$p->ID;				
								
				$tr_class = $this->alt? "class='alter $type'":"class='$type'";
								
				$this->alt = !$this->alt;									
				$editLink = $this->site."/wp-admin/post.php?action=edit&post=$ID";				
				$comment = $this->getComment($p->comment_status,$ID);				
				$google = $this->getGoogle($ID);				
				$permalink = get_permalink($ID);				
				$template = $type=="post"?"NA":$this->getTemplate($ID);			
				$delete = $this->getDelete($ID);

				$view = "<span class='view_icon'><a href='$permalink' target='_blank'>&nbsp;&nbsp;&nbsp;&nbsp;<a/></span>";
								
				$o ="<tr $tr_class id='tr_$ID'>".
					 '<td align="center"><input class="post_check" type="checkbox" name="sel" id="check_'.$ID.'" value="'.$ID.'"/></td>'.
					 "<td class='level_$level title'><a href='$editLink' target='_blank'>".$p->post_title."</a></td>".
					 "<td>$ID</td>".
					 "<td class='per'>".(str_replace($xsiteurl,"",$permalink))."</td>".
					 "<td class='date'>{$p->user_nicename}</td>".	
					 "<td class='date'>".date("Y-m-d",strtotime($p->post_modified))."</td>".				
					 ($type=="post"?"":"<td class='tem'>".$template."</td>").
					 "<td>$google</td>".
					 "<td class='icon'>$comment</td>".
					 "<td class='icon'>$view</td>".
					 "<td class='icon'>$delete</td>".
					 "</tr>\n";					 
				echo $o;
				if($isParent==false && $type=="page") { 
					$this->listPages("page",false,$p->ID,$level+1);
				}					
			}				 	 	
			
		}
	}//func		
	
	function getAllPages($type,$status,$parent=0,$isParentPage=false,$category=0){
		global $wpdb;
		
		$status = trim($status)==""?"publish":$status;
		
		$order = "";
					
		switch($_POST["post_order"]){
			case "created-a": $order = " ORDER BY post_date ASC "; break;
			case "created-d": $order = " ORDER BY post_date DESC "; break;
			case "modified-d": $order = " ORDER BY post_modified DESC "; break;
			case "modified-a": $order = " ORDER BY post_modified ASC "; break;
			case "title-d": $order = " ORDER BY post_title DESC "; break;
			default: $order = " ORDER BY post_title ASC "; break;
		}
					
		if($type=="post") {						
			$cat = $category==0?"":" term_id='$category'".
				   " AND taxonomy = 'category' AND  ";
				   							  																
			$ssql = "SELECT 
						  $wpdb->posts.post_title,
						  $wpdb->posts.ID,
						  $wpdb->posts.comment_status,
						  1 as sitemap,
						  post_date,
						  post_modified,
						  $wpdb->users.user_nicename
						FROM
						  $wpdb->term_taxonomy						  
						  INNER JOIN $wpdb->term_relationships ON ($wpdb->term_taxonomy.term_taxonomy_id = $wpdb->term_relationships.term_taxonomy_id)
						  INNER JOIN $wpdb->posts ON ($wpdb->term_relationships.object_id = $wpdb->posts.ID)
						  INNER JOIN $wpdb->users ON ($wpdb->posts.post_author = $wpdb->users.ID)
						WHERE
						  $cat 						  
						  post_status = '$status' AND 
						  post_type = 'post' AND 
						  post_parent = 0
						GROUP BY ID  						  
						$order";
			
			//echo $ssql;
					  														 
			$xpages = $wpdb->get_results($ssql);		
			//echo $wpdb->last_query."<br/>";			  
						  				  							
		} else {
			
			$parentFilter = $isParentPage?" ID = $parent ": " post_parent = $parent ";
			
			$sql = "SELECT 
					  $wpdb->posts.post_title,
					  $wpdb->posts.ID,
					  $wpdb->posts.comment_status,
					  post_modified,
					  $wpdb->users.user_nicename					  						  
					FROM
					  $wpdb->posts
					  INNER JOIN wp_users ON (wp_posts.post_author = wp_users.ID)
					WHERE
					  post_status = '$status' AND 
					  post_type = 'page'  AND 
					  $parentFilter
					GROUP BY ID 
					$order";
			
			//echo $sql;
						
			$xpages = $wpdb->get_results($sql);
										  																			 
		}	
		return $xpages;	
	} //func
	
	
	function getDelete($ID){
		$jsdel = "onclick=\"delPost($ID,this);\"";			
		$delete = "<span class='del_icon'><a class='pdel' $jsdel>&nbsp;&nbsp;&nbsp;&nbsp;</a></span>";
		return $delete;				
	}//func
	
	function getTemplate($ID){
		$template =  str_replace(".php","",get_post_meta($ID,"_wp_page_template",true));		
		if(strlen($template)>10){
			$template = substr($template,0,10)."...";
		}		
		return $template;		
	}//func
	
	
	function getGoogle($ID){
		$jsgoog = "onclick='enGO($ID,this);'";
		$google = "<span class='co'><a $jsgoog>".
				  (isset($this->google_blocked[$ID])?$this->google_blocked[$ID]:"allowed").
				  "</a></span> ";
		return $google;		  		
	} //func
	
	function getComment($comment_status,$ID){
		$new_stat = $comment_status =='closed'?1:0;				
		$js = "onclick='enCO($ID,this);'";
		$comment = "<span class='co'><a $js>".$comment_status."</a></span> ";
		return $comment;				
	} //func
	
	
	function cssAndScripts(){
		if($_GET["page"]!="cg-pp-lister/cg_pages.php") return;
		wp_enqueue_script("cg_pages_script",
						  WP_PLUGIN_URL."/cg-pp-lister/cg_pages_tool.js",
						  array("jquery"),
						  "1.0");
		echo '<link rel="stylesheet" href="'.WP_PLUGIN_URL.'/cg-pp-lister/cg_pages.css" type="text/css" />';		
	}//func	
	

	function ajax_enCOMass($idx,$status){
		global $wpdb;		
															
		$affected = $wpdb->query("UPDATE $wpdb->posts 
								  SET comment_status='$status' 
						      	  WHERE ID='$idx'");		

	} // func	
	
	function ajax_enCO(){
		global $wpdb;		
			
		if($_POST["id"]){
			$p = $_POST["id"];																
			$o = $wpdb->get_var("SELECT 								
									  $wpdb->posts.comment_status
									FROM
									  $wpdb->posts
									WHERE ID = '$p'");			  								
																							
			$status =$o == 'closed'?'open':'closed';
			
			$affected = $wpdb->query("UPDATE $wpdb->posts 
									  SET comment_status='$status' 
							      	  WHERE ID='$p'");		
			if($affected>0){
				echo $status;
			} else {
				echo "failed";
			}
		}; 
		die;
	} // func	
	
	function ajax_googleBlock($idx=0,$op=""){
		global $wpdb;
		
		$p = $idx==0?$_POST["id"]:$idx;
		$op = $op==""?$_POST["what"]:$op;	
		
		$key = strpos($_SERVER['SERVER_NAME'],"perrymarshall.com")===false?
			   "_cg_google_blocked":"_pm_google_blocked";
		
		if($op=="allowed"){
			// include																							
			$o = $wpdb->query("REPLACE INTO $wpdb->postmeta
							(post_id,meta_key,meta_value)
							VALUES   
							($p,'$key',1)");		
			if($idx==0) {
				echo "blocked";
				die();
			}
		} else {
			// exclude																					
			$o = $wpdb->query("DELETE FROM $wpdb->postmeta
							  WHERE meta_key='_cg_google_blocked' AND post_id='$p'");		
			if($idx==0){
				echo "allowed";
				die();
			}
		}		
	}//func		
		
	
	function ajax_include(){
		global $wpdb;
			if($_POST["id"]){
					$p = $_POST["id"];
					$include = $wpdb->query("DELETE FROM $wpdb->postmeta
									  	     WHERE post_id ='$p' AND meta_key ='_exclude_widgets'");		
					echo "Successfully added page ID $p on the SIDENAV";
				} else {
					echo "Failed";
			};		
		die;
	}//func;

	function ajax_exclude(){
		global $wpdb;
			if($_POST["id"]){
				$p = $_POST["id"];
					$exclude = $wpdb->query("REPLACE into $wpdb->postmeta
										  	 (post_id,meta_key,meta_value)
										  	 VALUES
										  	 ($p,'_widgets_exclude','1')");		
					echo "Successfully removed page ID $p on the SIDENAV";
				} else {
					echo "Failed";
				};		
		die;
	}//func;	
	
	function ajax_delPost(){
		global $wpdb;
			if($_POST["id"]){
				if(wp_delete_post($_POST["id"])) {
					echo "Successfully deleted the post/page.";
				} else {
					echo "Error deleting post/page.";
				};
			}
		die;
	}//func;		
	
}

//global functions

function cg_google_blocks(){
	global $post, $wpdb;	
	if($post->ID==""){
		return false;
	}
	$f = $wpdb->get_row("SELECT 
							  $wpdb->postmeta.post_id,
							  $wpdb->postmeta.meta_key
							FROM
							  $wpdb->postmeta
						 WHERE post_id='$post->ID' AND meta_key='_cg_google_blocked'");	
	if(count($f)){
		?>
			<!-- CG Google Meta (this post was tagged to be blocked from Google) -->	
			<meta name="robots" content="noindex">
			<meta name="googlebot" content="noindex">
			<meta name="robots" content="noarchive">
			<meta name="googlebot" content="noarchive">
			<meta name="googlebot" content="nosnippet">			
		<?php						
	}		
}//func

?>